#define _GNU_SOURCE

#include <sys/prctl.h>
#include <fcntl.h>
#include <pwd.h>
#include <sched.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

int main() {

    int fd = open("/run/vpn/net", 0);

    if (fd > 0) {
        int failure = setns(fd, CLONE_NEWNET);
        if (failure) {
            perror("setns /run/vpn/net");
        }
        close(fd);
        if (failure) {
            return 1;
        }
    } else {
        perror("open /run/vpn/net");
        return 1;
    }

    if(prctl(PR_CAP_AMBIENT, PR_CAP_AMBIENT_CLEAR_ALL, 0, 0, 0) == -1) {
        perror("prctl");
        return 1;
    }
    
    char shell[128] = {0};

    struct passwd *pw = getpwent();
    strlcpy(shell, pw->pw_shell, sizeof(shell));
    printf("%s\n", shell);
    endpwent();
    
    execl(shell, shell, NULL);
    perror(NULL);
    return 0;
}
